=== debian/changelog ===
libgmpada (0.0.20091124-4) unstable; urgency=low

  * control: (Architectures) any like all ada packages. Closes: #568441.
    see http://lists.debian.org/debian-ada/2010/02/msg00002.html)
    (Standards-Version) Updated to 3.9.0.0, no changes needed.
    (Vcs-Mtn) Corrected URL.
  * rules: SOVERSION and LIBNAME must be exported to upstream Makefile.
  * Switch to dpkg-source 3.0 (quilt) format.
  * (*-dev): depend on gnat, ada-compiler.
    (*-dbg): suggest gnat, gnat-4.4, ada-compiler.

  [Ludovic Brenta]
  * debian/control (DM-Upload-Allowed): yes, in anticipation of the
    application for DM status.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Thu, 01 Jul 2010 00:37:10 +0200

libgmpada (0.0.20091124-3) unstable; urgency=low

  * control: made each package description different to please lintian.
    (Architectures) explained why alpha is temporarily disabled.
  * patches: separated and documented removal of -gstabs+ and -fstack-check.
    Corrected an upstream incoherency in library project template.
  * watch: added.
  * rules: lintian override for shlib-with-executable-stack
    Generated separated debhelper files: more readability, less overloadings.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Wed, 20 Jan 2010 20:00:17 +0100

libgmpada (0.0.20091124-2) unstable; urgency=low

  * Patched demo/Makefile,devel.gpr,build.gpr: removed gcc flag -gstabs+
    in favor of more portable -g (FTBFS on ia64)
  * Closes: 559084 patched demo/Makefile to remove gcc flag -fstack-check
    Eric Botcazou says: "-fstack-check is broken with GCC 4.4 on x86/x86-64
    Linux, it generates code that will easily segfault"
    (http://gcc.gnu.org/PR20548).
  * rules;control;patches;README.source: added quilt support
  * control: XS-VCS- becomes Vcs- to please lintian
    (VCS-Mtn) new
    (VCS-Browser) official address
    (Architectures) any -> arch supporting GNAT to avoid dependency FTBFS

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Wed, 16 Dec 2009 00:04:29 +0100

libgmpada (0.0.20091124-1) unstable; urgency=low

  * New upstream version. Avoids collision with libgmp package.
  * control, rules: split -dev and -dbg packages.
  * docs, examples, rules: clarified, removed command embedding unwanted
    files, avoid compressing examples,
  * README.Debian: updated, conformed to other packages.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Tue, 24 Nov 2009 01:46:21 +0100

libgmpada (0.0.20091113-1) unstable; urgency=low

  * New package. Closes: #555682.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Fri, 13 Nov 2009 16:21:34 +0100
