=== debian/control ===
Source: libgmpada
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50~), gnat, gnat-4.4, libgmp3-dev, libmpfr-dev
Standards-Version: 3.9.0.0
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
Vcs-Mtn: www.ada-france.org org.debian.libgmpada
Homepage: http://mtn-host.prjek.net/projects/libgmpada

Package: libgmpada1-dev
Architecture: any
Depends: ${misc:Depends}, gnat, gnat-4.4, ada-compiler, libgmpada1 (= ${binary:Version})
Description: Ada binding to the GNU MultiPrecision library: development
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 Install this package if you want to write programs that
 use libgmpada.

Package: libgmpada1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada binding to the GNU MultiPrecision library: shared library
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 This package contains the runtime shared library.

Package: libgmpada1-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libgmpada1 (= ${binary:Version})
Recommends: libgmpada1-dev (= ${binary:Version})
Suggests: gnat, gnat-4.4, ada-compiler
Description: Ada binding to the GNU MultiPrecision library: debug symbols
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 This package contains the runtime debug symbols.
