=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2010 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

##########################################
# Guess some variables from control file.
##########################################
# LIB_NAME and SOVERSION must be exported to upstream Makefile.

export LIB_NAME := $(shell sed -n -e "s/^Source: lib\(.\+\)$$/\1/p" debian/control)
ifndef LIB_NAME
  $(error Could not guess LIB_NAME from debian/control)
endif

export SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\(.\+\)-dbg$$/\1/p" debian/control)
ifndef SOVERSION
  $(error Could not guess SOVERSION from debian/control)
endif

ALIVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\(.\+\)-dev$$/\1/p" debian/control)
ifndef ALIVERSION
  $(error Could not guess ALIVERSION from debian/control)
endif

SONAME := lib$(LIB_NAME).so.$(SOVERSION)
LIB_PKG := lib$(LIB_NAME)$(SOVERSION)
DBG_PKG := lib$(LIB_NAME)$(SOVERSION)-dbg
DEV_PKG := lib$(LIB_NAME)$(ALIVERSION)-dev
DOC_PKG := lib$(LIB_NAME)-doc

############################
# Ada Library Debian Helper
############################
# This a trick to use debhelper automation with external files,
# even if their names must match the package version.

# Each file named debian/ALDH.oldname is preprocessed and renamed
# according to these macros, before any build or install.  The
# preprocessed file is removed before any clean.
ALDH_macros := LIB_NAME ALIVERSION SOVERSION SONAME LIB_PKG DBG_PKG DEV_PKG DOC_PKG

ALDH_sed := sed $(foreach macro,$(ALDH_macros),-e s/$(macro)/$($(macro))/g)

define ALDH_template
ALDH_targets += $(2)
$(2): $(1)
	$(ALDH_sed) $(1) > $(2)
endef # ALDH_template

ALDH_targets :=
$(foreach template,$(wildcard debian/ALDH.*),\
  $(eval $(call ALDH_template,\
    $(template),\
    $(shell echo $(template) | $(ALDH_sed) -e s/ALDH.//))))

build binary binary-arch binary-indep install: $(ALDH_targets)

clean: ALDH_clean
.PHONY: ALDH_clean
ALDH_clean:
	rm -f $(ALDH_targets)

######################
# debhelper overrides
######################

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

.PHONY: build binary binary-arch binary-indep clean install
build binary binary-arch binary-indep clean install:
	dh $@

override_dh_compress:
	dh_compress --all --exclude=.ads --exclude=.adb --exclude=Makefile --exclude=.c --exclude=.h

override_dh_strip:
	dh_strip --package=$(LIB_PKG) --dbg-package=$(DBG_PKG)
	dh_strip --remaining-packages

override_dh_installdocs:
	dh_installdocs --all --link-doc=$(LIB_PKG)
