=== debian/changelog ===
libgmpada (0.0.20100805-2) unstable; urgency=low

  * compat, control: updated to debhelper 8.
  * rules: made dh targets more generic
  * patches: LDLIBS instead of LDFLAGS (ubuntu bug770987)

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Wed, 13 Jul 2011 14:45:18 +0200

libgmpada (0.0.20100805-1) unstable; urgency=low

  * New upstream release.
  * control: (Build-Depends) upstream now uses gprbuild.
    An unversioned libgmp-dev is now available.
    (Standards-Version) 3.9.2 without changes.
    Development package renaming, Conflicts & Replaces due to debian-ada-policy.
  * copyright: updated.
  * patches: two integrated upstream, one updated.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Mon, 09 May 2011 00:25:14 +0200
