=== debian/control ===
--- 
+++ 
@@ -3,15 +3,17 @@
 Priority: extra
 Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 7.0.50~), gnat, gnat-4.4, libgmp3-dev, libmpfr-dev
-Standards-Version: 3.9.0.0
+Build-Depends: debhelper (>= 8), gnat, gnat-4.4, libgmp-dev, libmpfr-dev, gprbuild
+Standards-Version: 3.9.2
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
 Vcs-Mtn: www.ada-france.org org.debian.libgmpada
 Homepage: http://mtn-host.prjek.net/projects/libgmpada
 
-Package: libgmpada1-dev
+Package: libgmpada2-dev
 Architecture: any
 Depends: ${misc:Depends}, gnat, gnat-4.4, ada-compiler, libgmpada1 (= ${binary:Version})
+Conflicts: libgmpada1-dev
+Replaces: libgmpada1-dev
 Description: Ada binding to the GNU MultiPrecision library: development
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and
@@ -37,7 +39,7 @@
 Section: debug
 Architecture: any
 Depends: ${misc:Depends}, libgmpada1 (= ${binary:Version})
-Recommends: libgmpada1-dev (= ${binary:Version})
+Recommends: libgmpada2-dev (= ${binary:Version})
 Suggests: gnat, gnat-4.4, ada-compiler
 Description: Ada binding to the GNU MultiPrecision library: debug symbols
  GMPAda allows programmers to use the GNU MultiPrecision library
