=== debian/rules ===
--- 
+++ 
@@ -90,8 +90,7 @@
 # Uncomment this to turn on verbose mode.
 # export DH_VERBOSE=1
 
-.PHONY: build binary binary-arch binary-indep clean install
-build binary binary-arch binary-indep clean install:
+%:
 	dh $@
 
 override_dh_compress:
