=== debian/changelog ===
libgmpada (0.0.20110925-2) unstable; urgency=low

  * rules: do not strip static archive.
  * lintian-overrides: wildcard instead of an explicit architecture.
  * README.Debian: should not depend on the architecture.
  * rules: get-orig-source and run-tests targets.
  * control (Build-Depends): a gprbuild providing -R option.
  * rules: replaced ALDH subsystem by debhelper overrides for readability.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Fri, 09 Dec 2011 23:48:58 +0100

libgmpada (0.0.20110925-1) unstable; urgency=low

  * New upstream release, a patch removed.
  * Build with gcc and gnat 4.6. Closes: #642642, #633569.
  * Multi arch support for library and -dev package.
    Build-Depends: debhelper >= 8.9.8 to accept new *.ali directory.
  * Package renaming due to debian-ada-policy:
    libgmpada2-dev -> libgmpada3-dev
    libgmpada1 -> libgmpada2
    libgmpada1-dbg -> libgmpada-dbg
  * source/options: max bzip2 compression for debian.tar
  * source/local-options: abort-on-upstream-changes, unapply-patches

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Sat, 01 Oct 2011 00:02:50 +0200
