## libgmpada 0.0.20120318

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
-#    Copyright (C) 2007-2011 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
+#    Copyright (C) 2007-2012 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 #
 #    This program is free software: you can redistribute it and/or modify
 #    it under the terms of the GNU General Public License as published by
@@ -19,13 +19,54 @@
 ########################
 
 LIB_NAME := gmpada
-SOVERSION := 1
+
+SOVERSION := $(shell sed -n 's/.*Soversion *:= *"\([[:digit:].]\+\)";.*/\1/p' $(LIB_NAME).gpr)
 
 ################################
 # Build and test configuration #
 ################################
 
-GPRBUILD_FLAGS :=
+# Default values if these variables are not set in the environment.
+# These flags are used in this Makefile as usual, in particular in the
+# implicit rule compiling generate_constants.c. Prefer overriding them
+# instead of cargs or largs..
+CFLAGS  ?= -g -O2
+LDFLAGS ?= -Wl,--as-needed
+# -g: produce debugging information
+# -O2: default optimization
+# -Wl,--as-needed: link only needed libraries
+
+# Gprbuild allows setting specific flags for each step (Compiler,
+# Binder, Linker, Gprbuild) and language.
+cargs     := $(CFLAGS)
+cargs_Ada := -gnatn -gnatw.e -gnatwH
+largs     := $(LDFLAGS)
+gargs     := -R -s -j$(shell getconf _NPROCESSORS_ONLN)
+# -gnatn: allow subprogram inlining
+# -gnatw.e: activate all optional warnings
+# -gnatwH: except hiding
+# -R: no run path option
+# -s: recompile if compilation switches have changed
+
+# Here is the exhaustive flag list.
+gpr_flag_names := \
+  cargs cargs_Ada cargs_C \
+  bargs bargs_Ada bargs_C \
+  largs largs_Ada largs_C \
+  gargs
+
+
+# Note that -gargs must come last, or else following flags will be
+# interpreted as linker flags.
+
+# Build the actual command line flags. For readability, only append
+# the non-empty variables.
+define append_gprbuild_flag
+  ifneq (,$$($(1)))
+    GPRBUILD_FLAGS += -$(subst _,:,$(1)) $$($(1))
+  endif
+endef
+$(foreach var,$(gpr_flag_names),$(eval $(call append_gprbuild_flag,$(var))))
 
 ##############################
 # Installation configuration #
@@ -51,45 +92,37 @@
 # Rules #
 #########
 
-build: src/gmp-constants.ads
-	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs Makefile_build.gpr \
-          -XKIND=dynamic \
-          -XNAME=$(LIB_NAME) \
-          -XVERSION=lib$(LIB_NAME).so.$(SOVERSION)
-	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs Makefile_build.gpr \
-          -XKIND=static \
-          -XNAME=$(LIB_NAME)
+build: build-dynamic build-static
+
+build-dynamic build-static: build-%: src/gmp-constants.ads
+	gprbuild $(GPRBUILD_FLAGS) $(LIB_NAME).gpr -XKIND=$*
 clean::
-	rm -rf $(foreach dir,obj lib,$(foreach kind,dynamic static,build-$(dir)-$(kind)))
+	rm -f $(foreach dir,obj lib,$(foreach kind,dynamic static,build-$(dir)-$(kind)/*))
 
 src/gmp-constants.ads: generate_constants
 	./$< > $@
 clean::
 	rm -f src/gmp-constants.ads
 
-generate_constants: CFLAGS += -Wall -Wextra
-generate_constants: LDLIBS += -lgmp
+generate_constants: LDLIBS := -lgmp
 clean::
 	rm -f generate_constants
 
 clean::
 	find -name "*~" -delete
 
-test: src/gmp-constants.ads
-	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs Makefile_test.gpr
-	cd test-obj && ./demo
+test: build-static
+	gprbuild $(GPRBUILD_FLAGS) demo/demo.gpr -XKIND=static
+	demo/demo
 clean::
-	rm -rf test-obj
+	rm -f demo/demo demo/obj/*
 
 install: build
 	install --directory $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
-	install --mode=644 src/* $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
+	install --mode=644 src/*.ad[sb] src/*.[ch] $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
 	install --directory $(DESTDIR)/$(GPR_DIR)
 	sed template_for_installed_project \
-          -e "s|\$$(LIB_NAME)|$(LIB_NAME)|g" \
-          -e "s|\$$(SOURCE_DIR)|/$(SRC_DIR)/$(LIB_NAME)|g" \
-          -e "s|\$$(LIBRARY_ALI_DIR)|/$(ALI_DIR)/$(LIB_NAME)|g" \
-          -e "s|\$$(LIBRARY_DIR)|/$(LIB_DIR)|g" \
+          $(foreach var,LIB_NAME SRC_DIR ALI_DIR LIB_DIR,-e 's|$$($(var))|$($(var))|g') \
           > $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
 	chmod 644 $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
 	install --directory $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
@@ -107,4 +140,25 @@
 	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so.$(SOVERSION)
 	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so
 
-.PHONY: build clean install test uninstall
+# Paranoid flags for developpers.
+
+# -g: debugging information
+# -Wall: optional warnings
+# -Wextra: extra warnings
+# -fstack-check: stack overflow checking
+# -gnatf: full errors
+# -gnatq: dont’quit
+# -gnatQ: generate ALI files for cross-ref
+# -gnata: Assert and Debug pragmas
+# -gnatVa: all validity checks
+# -gnaty: all style checks
+# -gnatyM159: max line length
+# -gnato: runtime overflow checking
+# -gnatE: checks for access-before-elaboration
+# -E: exception backtraces
+devel:
+	$(MAKE) test CFLAGS="-g -O2 -Wall -Wextra -fstack-check" \
+             cargs_Ada="-gnatn -gnatw.e -gnatwH -gnatf -gnatq -gnatQ -gnata -gnatVa -gnaty -gnatyM159 -gnato -gnatE" \
+             bargs_Ada=-E
+
+.PHONY: build build-dynamic build-static clean devel install test uninstall
