=== debian/changelog ===
libgmpada (0.0.20120318-1) unstable; urgency=low

  * New upstream release (only build system changes).
  * README.Debian: replaced with a short reference to policy.
  * control: debhelper 9, Standards-Version 3.9.3 (no changes)
  * rules: simplified flags transmission
  * tests: create obj dir to conform to new upstream.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Sun, 18 Mar 2012 06:18:31 +0100

libgmpada (0.0.20110925-3) unstable; urgency=low

  * control: remove dependencies on ada-compiler virtual package.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Thu, 09 Feb 2012 20:50:50 +0100
