=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: extra
 Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 DM-Upload-Allowed: yes
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 8.9.8),
+Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
  gnat, gnat-4.6, gprbuild (>= 2011),
  libgmp-dev, libmpfr-dev
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
 Vcs-Mtn: www.ada-france.org org.debian.libgmpada
 Homepage: http://mtn-host.prjek.net/projects/libgmpada
@@ -14,8 +14,10 @@
 Package: libgmpada3-dev
 Architecture: any
 Depends: ${misc:Depends},
- gnat, gnat-4.6, ada-compiler,
- libgmpada2 (= ${binary:Version})
+ gnat, gnat-${ada:GNAT-VERSION},
+ ${ada:LIB-PKG} (= ${binary:Version})
+Conflicts: ${ada:OLD-DEV-PKGS}
+Replaces: ${ada:OLD-DEV-PKGS}
 Description: Ada binding to the GNU MultiPrecision library: development
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and
@@ -44,9 +46,9 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, libgmpada2 (= ${binary:Version})
-Recommends: libgmpada3-dev (= ${binary:Version})
-Suggests: gnat, ada-compiler
+Depends: ${misc:Depends}, ${ada:LIB-PKG} (= ${binary:Version})
+Recommends: ${ada:DEV-PKG} (= ${binary:Version})
+Suggests: gnat
 Description: Ada binding to the GNU MultiPrecision library: debug symbols
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and
