=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 ##############
 
 # Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
-# Copyright (c) 2009-2011 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
+# Copyright (c) 2009-2012 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 
 # This build script is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License as
@@ -29,8 +29,11 @@
 # Set some variables #
 ######################
 
-# Export CFLAGS and LDFLAGS to upstream Makefile.
-DPKG_EXPORT_BUILDFLAGS = 1
+# Magic stuff from GNU Make manual.
+comma := ,
+empty :=
+space := $(empty) $(empty)
+
 include /usr/share/dpkg/default.mk
 
 LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))
@@ -45,14 +48,23 @@
   $(warning Could not guess ALIVERSION from debian/control)
 endif
 
+# Gnat version has to be mentioned in Build-Depends anyways.
+GNAT_VERSION := $(shell sed -n -e "s/.*gnat-\([[:digit:].]\+\),.*/\1/p" debian/control)
+ifndef GNAT_VERSION
+  $(warning Could not guess GNAT_VERSION from debian/control)
+endif
+
 LIB_PKG := lib$(LIB_NAME)$(SOVERSION)
 DBG_PKG := lib$(LIB_NAME)-dbg
 DEV_PKG := lib$(LIB_NAME)$(ALIVERSION)-dev
 DOC_PKG := lib$(LIB_NAME)-doc
 
-# -R: avoid setting run path option (aka rpath)
-# -j: number of jobs
-GPRBUILD_FLAGS := -R -j$(shell getconf _NPROCESSORS_ONLN)
+# Fill OLD_ALIVERSIONS by hand with obsolete aliversions that depends
+# on the same gnat version. See debian-ada-policy for details.
+OLD_ALIVERSIONS :=
+OLD_DEV_PKGS := \
+  $(subst $(space),$(comma) ,$(patsubst %,lib$(LIB_NAME)%-dev, \
+  $(OLD_ALIVERSIONS)))
 
 ######################
 # debhelper overrides
@@ -69,23 +81,14 @@
 override_dh_clean::
 	dh_clean
 
-override_dh_auto_build:
-	dh_auto_build -- \
-          LIB_NAME=$(LIB_NAME) \
-          SOVERSION=$(SOVERSION) \
-          GPRBUILD_FLAGS="$(GPRBUILD_FLAGS)"
-
-override_dh_auto_test:
-	dh_auto_test -- \
-          LIB_NAME=$(LIB_NAME) \
-          GPRBUILD_FLAGS="$(GPRBUILD_FLAGS)"
-
-override_dh_auto_install:
-	dh_auto_install -- \
-          LIB_NAME=$(LIB_NAME) \
-          SOVERSION=$(SOVERSION) \
-          ALI_DIR=usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib \
-          LIB_DIR=usr/lib/$(DEB_HOST_MULTIARCH)
+# CFLAGS is good for gcc, but Ada sources do not need format
+# hardening (in gprbuild options we want that Ada do not receive the
+# format hardening.
+override_dh_auto_build override_dh_auto_test override_dh_auto_install: override_%:
+	$* -- cargs="$(filter-out -Wformat% -Werror=format%,$(CFLAGS))" \
+              cargs_C="$(filter -Wformat% -Werror=format%,$(CFLAGS))" \
+              ALI_DIR=usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib \
+              LIB_DIR=usr/lib/$(DEB_HOST_MULTIARCH)
 
 override_dh_install:
 	dh_install --package=$(DEV_PKG) usr/share/ada/adainclude
@@ -137,6 +140,14 @@
 	dh_strip --package=$(DEV_PKG) --exclude=.a
 	dh_strip --remaining-packages
 
+override_dh_gencontrol:
+	dh_gencontrol -- $(foreach var, \
+          DEV_PKG \
+          GNAT_VERSION \
+          LIB_PKG \
+          OLD_DEV_PKGS \
+          , '-Vada:$(subst _,-,$(var))=$($(var))')
+
 ######################################################################
 
 GET_ORIG_MTN := mtn://www.ada-france.org?net.prjek.mtn-host.libgmpada
